<?php
/**
 * This file is part of the JustKnit package.
 *
 * @copyright JustKnit (Iris Hammer) <iris@justknit.de>
 * @license All rights reserved (@https://dejure.org/gesetze/UrhG/69a.html)
 * Created on 03-20-2023
 *
 * @package justknit
 */

namespace JustKnit\Controllers\Register;

use MODX\Revolution\modX;
use MODX\Revolution\modUser;
use MODX\Revolution\modUserProfile;
use JustKnit\Model\JustKnitClientMeta;
use JustKnit\Model\JustKnitProduct;
use JustKnit\Model\JustKnitOrder;
use JustKnit\Controllers\Register\Base;

class IpnDS24 extends Base {
        /** @var array $post An array of posted values from DS24 */
    public $post = [];
    /**
     * Load default properties for this controller.
     *
     * @return void
     */
    public function initialize()
    {
        $this->setDefaultProperties([
            'toJson'         => true,
            'DS24HeadTpl'    => 'JustKnit.DS24HeadChunk',
            'DS24KeyTpl'     => 'JustKnit.DS24KeyChunk',
            'DS24HeadRtnTpl' => 'JustKnit.DS24HeadRtnChunk',
            'DS24KeyRtnTpl'  => 'JustKnit.DS24KeyRtnChunk',
            'primary_group'  => false,
            'blocked'        => false,
            'active'         => true,
            'client_deleted' => false,
        ]);
    }

    /**
     * Handle the JustKnit Ipn logic.
     *
     * @return string
     */
    public function process()
    {
        if (!$this->hasPost()) {
            $this->modx->log( modX::LOG_LEVEL_ERROR,'[JustKnit] Payment: no valid $_POST ');
            return '';
        }
        $fields = $this->dictionary->toArray();
$this->modx->log( modX::LOG_LEVEL_ERROR,'[JustKnit] $fields '. print_r($fields, 1));
        $this->user = getUserByEmail($fields['email']);
        if (!$this->user) {
            $this->modx->log( modX::LOG_LEVEL_ERROR,'[JustKnit] Payment: User not found with email '. $fields['email']);
            return '';
        }
        $this->profile = $this->user->getOne('Profile');
        $this->clientmeta = getClientMetaByUserId($this->user->get('id'));

        $this->order_id = $fields['order_id'];
        $this->order = $this->getOrder();
        if (!$this->order) {
            $this->modx->log( modX::LOG_LEVEL_ERROR,'[JustKnit] Payment: Order not found with order_id '. $fields['order_id']);
            return '';
        }
        // save transaction

        // check [transaction_type] if !payment deactivate modUser
/*        if () {

        }
        // check if the
*/
/**
 * Hier muss dann rein, dass jede transaction gespeichert wird.
 * siehe @Brainstorm.jk@MODX3.ods.$DatenFlowIpn.
 * in der transaction sind dann byer_id, oder_id, product_id, und die ganzen Zahlungsdaten
 * incl. Verdienst und Provision.
 * über [transaction_type] => [payment, refund, chargeback, refund_request] wird dann
 * ausgelöst, falls eine Rückgabe erfolgt. Dann muss der modUser['active'] auf 0 gesetzt werden
 * und modUserProfile['blockedafter'] auf das aktuelle Datum
 *
 */


        return true;
    }
}
