<?php
/**
 * Processor file for justknit extra
 *
 * Copyright 2023 by Iris Hammer iris@justknit.de
 * Created on 03-20-2023
 *
 * justknit is free software; you can redistribute it and/or modify it under the
 * terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * justknit is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
 * A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * justknit; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * @package justknit
 * @subpackage processors
 */

/* @var $modx modX */

namespace JustKnit\Processors;

use JustKnit\Model\JustKnitSubscriberMeta;
use MODX\Revolution\modX;
use MODX\Revolution\Processors\Processor;


class JustKnitSubscribers extends Processor{
    public function process()
    {
        $count = $this->modx->getCount(JustKnitSubscriberMeta::class);
        $this->modx->log(modX::LOG_LEVEL_ERROR,'$count: ' . $count);
        return $this->success('Anzahl Subscribers: ' . $count);
    }
}

// return 'justknitProcessor';
//
//
//     public $classKey = 'mod';
//     public $languageTopics = array('justknit:default');
//     public $defaultSortField = 'name';
//     public $defaultSortDirection = 'ASC';
//     public $ids;
//
//     function initialize() {
//         /* Initialization here */
//         return true;
//     }
//
//     /* For built-in processors (create, update, duplicate, remove),
//        this method can be removed */
//     public function process() {
//
//         /* perform action here */
//
//         return $this->success();
//
//     }
